use std::fmt;
use std::any::Any;
use std::future::Future;

use super::api_capnp::machine::read::Client;

pub struct Machine {
    read: Option<Client>,
}
impl fmt::Debug for Machine {
    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {
        let mut b = f.debug_struct("Machine");
        if let Some(r) = self.read.as_ref() {
            b.field("read", &r.type_id());
        }
        b.finish()
    }
}

impl Machine {
    pub fn new(read: Option<Client>) -> Self {
        Machine {
            read,
        }
    }

    pub fn get_info(&self) -> impl Future<Output=Option<String>> {
        futures::future::ready(None)
    }
}
